import { IDType, DataObject, NewData, InvalidMessage, RESTClient } from './utility';
export declare abstract class BaseModel {
    downloading: number;
    uploading: number;
    clear(): void;
}
export declare abstract class BaseListModel<D extends DataObject> extends BaseModel {
    abstract client: RESTClient;
    abstract baseURI: string;
    indexKey: keyof D;
    currentOne: D;
    validity: InvalidMessage<D>;
    static createNested(parentId: IDType): BaseListModel<{}>;
    clearCurrent(): void;
    clear(): void;
    updateOne(data: NewData<D>, id?: IDType): Promise<D>;
    getOne(id: IDType): Promise<D>;
    deleteOne(id: IDType): Promise<void>;
}
